event         = require("component-event")
expect        = require("../util/expect")
createRequest = ->

hijack = module.exports =
	###
	# Listen to all url change events on a dom element and trigger the server callback.
	#
	# @param {DOMNode} element
	# @api private
	###
	listen: (element = window)->
		event.bind(element, "DOMContentLoaded", handleChange)
		event.bind(element, "popstate", handleChange)
		event.bind(element, "submit", handleClick)
		event.bind(element, "click", handleClick)
		return hijack

	###
	# Add a handler to listen to url changes.
	#
	# @param {Function} handler
	# @api private
	###
	createServer: (handler)->
		createRequest = handler
		return hijack

	###
	# Trigger the registered handler to navigate to a given url.
	#
	# @param {String} url
	# @param {Object} options
	# @api private
	###
	goTo: (url, { method, headers, body, title } = {})->
		title ?= ""
		req    =
			url:     url
			body:    body
			method:  method ? "GET"
			headers: headers ? {}

		
		createRequest(req).then(({ redirected })->
			window.history.pushState(req, title, url) unless redirected
			return
		)

{ handleClick, handleChange } = require("./handlers")
