noop = -> yield return

###
# Compose `middleware` returning
# a fully valid middleware comprised
# of all those which are passed.
#
# @param {Array} middleware
# @return {Function}
# @api private
###
module.exports = (middleware)-> (req, res, next)->
	i     = middleware.length
	next ?= noop
	next  = middleware[i].call(@, req, res, next) while i--
	yield next
